Skip to content

Retrieves payment session details by ID

Request

GET {{baseURL}}/v2/payment-sessions/{{paymentSessionId}}

This endpoint retrieves the details of the specified payment session by ID.

See Also:
To create a new payment session, see POST /v2/payment-sessions.
To cancel a payment session, see POST /v2/payment-sessions/{{paymentSessionId}}/cancel.

Security
Bearer
Path
paymentSessionIdstring, (uuid)required

Specifies the payment session identifier.

Example:edf7b36a-1b2c-4d3e-4f5a-6b7c8d9e0f36
curl -i -X GET \
  https://sandbox.api.flute.com/v2/payment-sessions/edf7b36a-1b2c-4d3e-4f5a-6b7c8d9e0f36 \
  -H 'Authorization: Bearer <YOUR_JWT_HERE>'

Responses

OK

Bodyapplication/json
statusstring or nullread-only

Indicates the payment session status.

Valid values:

StatusDescription
CreatedPayment session was initialized but not yet processed.
CompletedPayment session was completed. Check transaction details to verify if the payment was approved or not.
CancelledPayment session was canceled before completion.
ExpiredPayment session expired before being completed.
FailedPayment was attempted but did not succeed. A new session must be created for a new payment attempt.

Example: Created

Example:"Created"
modestring, (enum)

Indicates the intent of the session.

NameDescription
PaymentStandard payment session.
SaveMethodVault-only session to store a payment method. The amount must be zero.

No payment is processed. This stores the customer's card details for future use. vaultedPaymentMethodId is returned on the session once confirmed.
PaymentAndSaveCharge the payment and store the customer's card details for future use.

vaultedPaymentMethodId is returned on the session once confirmed.

Example: Payment

Default:"Payment"
Enum:"Payment""SaveMethod""PaymentAndSave"
Example:"Payment"
skipAddressVerificationboolean

Indicates to bypass the AVS (address verification service) in the payment gateway.

This value is applicable only to Payment and PaymentAndSave from mode.

If true, bypasses AVS in the payment gateway.
If false, does not bypass AVS in the payment gateway.

Example: true

Default:false
Example:true
customerIdstring or null, (uuid)

Identifies the customer to link this payment method to.

This value may be null when this payment method is an orphan owned by the merchant directly. An orphan payment method is a payment method in the merchant's vault but has no customer record associated with it.

Example: 8fa8e727-73c6-436e-b56f-6f55aabf3b1c

Example:"8fa8e727-73c6-436e-b56f-6f55aabf3b1c"
vaultedPaymentMethodIdstring or null, (uuid)

Indicates the identifier of the vaulted payment method when the session involves saving or using a stored payment method.

Example: 990a65f4-519c-44f9-a615-fc9c7781190c

Example:"990a65f4-519c-44f9-a615-fc9c7781190c"
referenceIdstring or null, [ 0 .. 36 ] characters

Indicates a reference identifier provided by the merchant.

This is included in the duplicate-check key. It allows the same card and amount combination to be charged multiple times when the reference identifiers are different.

Example: REF-EXT-12345

Example:"REF-EXT-12345"
tipAmountnumber or null, (double), decimal places <= 2

Indicates the absolute amount (in USD) of the tip to be added.

If this value is provided, it must be greater than zero.

Example: 14.50 (for $14.50)

Example:14.5
returnUrlstring or null

Indicates the URL to redirect the payer to after a successful payment.

This value is not needed if using Flute Elements and Flute Checkout.

Example: https://api.payments.flute.com/xOut/sessions/session-complete.html

Example:"https://api.payments.flute.com/xOut/sessions/session-complete.html"
paymentLinkIdstring or null, (uuid)

Indicates the payment link that generated this payment session, when applicable.

This value is null for a payment session created directly through POST /v2/payment-sessions.

Example: 6f2a8b3c-9d4e-4f1a-8b7c-3e5d6a9f0c1b

Example:"6f2a8b3c-9d4e-4f1a-8b7c-3e5d6a9f0c1b"
paymentMethodsobject

Identifies the payment methods a payment link accepts. It is keyed by method so each one carries only the configuration that applies to it.

metadataobject or null

Indicates arbitrary key-value pairs to attach to the payment session object.

These values are used to store supplemental information. They are not functionally used in this endpoint. Instead, they are included while retrieving the payment session. This allows additional notes to be passed along to the operator.

Pass null to clear all metadata.

Examples:
[ {"orderId": "9921"} ]
[ {"Guest notes": "Member of The World of Hyatt Credit Card."} ]
[{"orderId": "9921"}, {"Guest notes": "Member of The World of Hyatt Credit Card."}]

Example:
[ { "orderId": "9921" }, { "Guest notes": "Member of The World of Hyatt Credit Card." } ]
afterCompletionMessagestring or null

Specifies a message shown to the payer after the payment session completes.

This value is not needed if using Flute Elements and Flute Checkout.

Example: Thank you for shopping with us.

Example:"Thank you for shopping with us."
pageNamestring or null

Specifies the display name shown on the checkout page.

This is a free-formed name that is convenient for the merchant to recognize.

Example: Peppared Street Cafe's Preferred Payment

Example:"Peppared Street Cafe's Preferred Payment"
expiresAtstring or null, (date-time)

Specifies the expiration timestamp (in an ISO 8601 date-time UTC format) for the payment session.

The time must be in the future.

Example: 2026-02-19T20:24:52.934Z

Example:"2026-02-19T20:24:52.934Z"
paymentNotesstring or null

Specifies additional notes shown to the payer on the checkout page.

Example: The client's server is being repaired.

Example:"The client's server is being repaired."
achAccountLast2string or null

Indicates the last two digits of an ACH (automated clearing house) bank account number.

Example: 84

Example:"84"
achRoutingLast2string or null

Indicates the last two digits of an ACH (automated clearing house) bank routing number.

Example: 62

Example:"62"
surchargeAmountnumber, (double)

Specifies the surcharge amount (in USD) applied.

Example: 18.45 (for $18.45)

Example:18.45
transactionDetailsobject
Response
{ "status": "Created", "mode": "Payment", "skipAddressVerification": true, "customerId": "8fa8e727-73c6-436e-b56f-6f55aabf3b1c", "vaultedPaymentMethodId": "990a65f4-519c-44f9-a615-fc9c7781190c", "referenceId": "REF-EXT-12345", "tipAmount": 14.5, "returnUrl": "https://api.payments.flute.com/xOut/sessions/session-complete.html", "paymentLinkId": "6f2a8b3c-9d4e-4f1a-8b7c-3e5d6a9f0c1b", "paymentMethods": { "card": { "enabled": true, "processorId": "d529945e-8d10-4cb4-9dc3-718e57f3f14e" }, "ach": { "enabled": true, "processorId": "d529945e-8d10-4cb4-9dc3-718e57f3f14e" } }, "metadata": [ { "orderId": "9921" }, { "Guest notes": "Member of The World of Hyatt Credit Card." } ], "afterCompletionMessage": "Thank you for shopping with us.", "pageName": "Peppared Street Cafe's Preferred Payment", "expiresAt": "2026-02-19T20:24:52.934Z", "paymentNotes": "The client's server is being repaired.", "achAccountLast2": "84", "achRoutingLast2": "62", "surchargeAmount": 18.45, "transactionDetails": { "transactionReceiptUrl": "https://receipts.flute.com/r/90d084d6-55b8-4fb8-b658-861534d07f9a", "transactionReceiptShortUrl": "https://s.flute.com/745iZYxF83t", "source": { "name": "Front Counter Terminal", "type": "Terminal", "id": "5e6e2ad1-8c9d-4e0f-1a2b-3c4d5e6f7a03", "typeId": 0, "version": "1.4.2" }, "transactionReceipt": { "transactionId": "f01339ec-8184-48c7-b58d-0780d6499ef4", "transactionDateTime": "2026-05-05T14:30:42.938Z", "amount": { "baseAmount": 99.99, "percentageOffAmount": 12.5, "percentageOffRate": 3.5, "cashDiscountAmount": 12.5, "cashDiscountRate": 1.5, "surchargeAmount": 22, "surchargeRate": 2.5, "tipAmount": 14.5, "tipRate": 18.5, "taxAmount": 3.75, "taxRate": 8.5, "totalAmount": 124.99 }, "currency": "USD", "processorId": "76215e54-a85b-4d42-9553-163fe393cb02", "processor": "TSYS", "operationTypeId": 0, "operationType": "PayNow", "paymentMethodTypeId": 0, "paymentMethodType": "Card", "transactionTypeId": 0, "transactionType": "AchDebit", "customerId": "8fa8e727-73c6-436e-b56f-6f55aabf3b1c", "customerPan": "************1111", "cardTokenType": "Local", "statusId": 0, "status": "Completed", "merchantName": "Peppared Street Cafe", "merchantAddress": "123 Main St, Suite 100, New York", "merchantPhoneNumber": "+14155552309", "merchantEmailAddress": "peppared@example.com", "merchantWebsite": "PepparedStreetCafe.example.com", "authCode": "ABC123", "source": { "name": "Front Counter Terminal", "type": "Terminal", "id": "5e6e2ad1-8c9d-4e0f-1a2b-3c4d5e6f7a03", "typeId": 0 }, "cardholderAuthenticationMethodId": "PIN", "cardholderAuthenticationMethod": "PIN", "cvmResultMsg": "Signature Verified", "cardDataSourceId": "string", "cardDataSource": "Swipe", "responseCode": "00", "responseDescription": "Declined - Do Not Honor", "cardProcessingDetails": { "authCode": "ABC123", "mid": "700123456789", "tid": "00012345", "rrn": "625031412345", "cardCreditDebitType": "Credit", "processCreditDebitType": "Credit", "cardType": "Visa" }, "achProcessingDetails": { "customerAccountNumber": "4111111111111111", "customerRoutingNumber": "867320021", "accountHolderType": "Business", "accountType": "Checking", "taxId": "12-3456789" }, "availableOperations": [ { "type": "AchDebit", "availableAmount": 49.99, "suggestedTips": [ { "tipPercent": 18.5, "tipAmount": 14.5 } ] } ], "avsResponse": { "action": "Allow", "responseCode": "Y", "codeDescription": "Address and ZIP code match", "group": "NoMatch", "result": "Passed" }, "emvTags": { "ac": "A123456789ABCDEF", "tvr": "0000008000", "tsi": "E800", "aid": "A0000000031010", "applicationLabel": "VISA CREDIT", "rawTags": [ { "key": "ac", "value": "9F26" } ] }, "orderNumber": "ORD-4521" }, "id": "39a95e35-6d50-45ec-884b-c2417edf005d", "paymentProcessorId": "76215e54-a85b-4d42-9553-163fe393cb02", "date": "2025-02-19T20:24:52.934Z", "amount": { "baseAmount": 125.5, "percentageOffAmount": 12.5, "percentageOffRate": 3.5, "cashDiscountAmount": 12.5, "cashDiscountRate": 1.5, "surchargeAmount": 22, "surchargeRate": 2.5, "tipAmount": 14.5, "tipRate": 18.5, "taxAmount": 3.75, "taxRate": 8.5, "totalAmount": 124.99 }, "currencyCode": "USD", "currencyId": 0, "createdBy": "Alexandro Peppared", "merchant": "Peppared Street Cafe", "processorId": "76215e54-a85b-4d42-9553-163fe393cb02", "processor": "TSYS", "operationMode": "Card", "paymentMethodType": "Card", "paymentMethodTypeId": 0, "paymentMethodName": "Cafe Peppared Payments", "customerId": "8fa8e727-73c6-436e-b56f-6f55aabf3b1c", "customerName": "Alexandro Peppared", "customerCompany": "Peppared Street Cafe", "customerPan": "************1111", "customerEmail": "peppared@example.com", "customerPhone": "+14155552309", "status": "Completed", "statusId": 0, "responseCode": "00", "responseMessage": "Approved", "responseDescription": "Declined - Do Not Honor", "avsResponseCode": "Y", "availableStates": [ "string" ], "refunded": false, "cardType": "Visa", "typeId": 0, "type": "string", "creditDebitTypeId": 0, "creditDebitTypeType": "Credit", "authCode": "ABC123", "mid": "700123456789", "tid": "00012345", "referenceId": "REF-EXT-12345", "merchantId": "5611f824-48ef-4255-978d-91ce13953bbd", "availableOperations": [ { "type": "AchDebit", "availableAmount": 49.99, "suggestedTips": [ { "tipPercent": 18.5, "tipAmount": 14.5 } ] } ], "avsResponse": { "action": "Allow", "responseCode": "Y", "codeDescription": "Address and ZIP code match", "group": "NoMatch", "result": "Passed" }, "histories": [ { "id": "39a95e35-6d50-45ec-884b-c2417edf005d", "transactionDateTime": "2026-05-05T14:32:15.867Z", "transactionAmount": 124.99, "transactionType": "AchDebit", "transactionStatus": "Approved" } ] } }